/*-
 * mkabs:   This module produces a single omf-module which declares a
 *    single absolute symbol.
 *    There is an 'optional' parameter; which is the name of a symbol
 *    which should be externally 'referenced' by this module.   Note
 *    that this reference is a "dummy" which forces the linker to 
 *    bring said module into the load file.
 */

#include <libc.h> 
#include "codegen.h"


mkabs(FILE *f, char *name, char *xib, long addr)
{

	FILE *fp = fopen("tmp.s", "w");

	fprintf(fp, ".file __(absolute)__%s\n", name);
	if (xib) {
		fprintf(fp, ".extrn %s\n", xib);
	}
	fprintf(fp, ".long %s = $%x\n", name, addr);
	fprintf(fp, ".end\n");
	fclose(fp);
	gas("tmp.s", f);
	return 0;
}
