/*-
 * codegen.h: manifests and declarations for code generating routines
 */

#ifndef codegen_h
#define codegen_h


struct jmptab {
        char          *jl_modnam;       /* module name */
	char          *jl_start;	/* jump table label */
	char          *jl_end;		/* end of jump table */
	char          *jl_relocp;	/* relocation pointer */
	long           j_offset;        /* base offset of jump table */     
	char         **j_vec;           /* vector */ 
	int            j_nvec;          /* number of entries in vec */
};
extern int mkxib(FILE *f, char *modname, char *extnam,
			char *pubnam, int prio, int needflt);
extern int mkabs(FILE *f, char *symnam,  char *optxib, long paddr);

extern int mk_jump(FILE *fp, char *lsym, char *rsym);
extern int mkjumptable(FILE *fout, struct jmptab *jp);
extern int mktextpad(FILE *fp, long padlen);
extern int mketext(FILE *fp);

extern int mkdummy(FILE *fp, long baddr, long bsize);

#define ALIGN(_x,_y)  (((int)(_x)+1) & ~((_y)-1))
#define ALIGNVAL sizeof(long)
#define RESERVED	(ALIGNVAL * 2)
#define SO_ADDRESS(_index)   (RESERVED + (_index-1)*ALIGNVAL*2)

#ifndef PAGELEN
#define PAGELEN 0x1000
#endif

#define ROUND_PAGE(x)  (((x)+(PAGELEN-1)) & ~(PAGELEN-1))

#endif
