#include <libc.h>
#include "mkshlib.h"

static int      d_level = 0;
static FILE    *d_file = 0;

int
diag_close(void)
{
	if (d_file)
		fclose(d_file);
	d_file = 0;
	return 0;
}

int
diag_level(int nlevel)
{
	int             l = d_level;
	d_level = nlevel;
	return l;
}

int
diag_file(char *fname)
{
	FILE           *fp;
	if ((fp = fopen(fname, "w")) == 0) {
		fprintf(stderr, "cannot open diagnostic file '%s' (%s), diagnostics disabled\n",
			fname, strerror(errno));
		return -1;
	}
	d_file = fp;
	atexit(diag_close);
	return 0;
}
int
diag_msg(int level, char *fmt,...)
{
	va_list         varg;
	if (!d_file || level < d_level) {
		return 0;
	}
	va_start(varg, fmt);
	vfprintf(d_file, fmt, varg);
	va_end(varg);
	return 0;
}
int
diag_write(int level, char *buf, int n)
{
	if (!d_file || level < d_level) {
		return 0;
	}
	fwrite(buf, n, 1, d_file);
	return 0;
}
