#ifndef mkshlib_h
#define mkshlib_h

#ifndef _STDIO_H_INCLUDED
#include <stdio.h>
#endif

#ifndef ShObjDef_h
#include "ShObjDef.h"
#endif

#define TEMP_TARGET    "mksh_tar_"
#define TEMP_HOST      "mksh_host_"

/*
 * naming conventions for generated symbols.
 */
#define FMT_SO_BIND	"__so%s_bind"
#define FMT_SO_IMP	"__so%s_import"
#define FMT_SO_EXPBEG   "__so%s_exportbeg"
#define FMT_SO_EXPEND   "__so%s_exportend"

#define SO_MAGIC	0765432123
#define SO_VERSION	1


#ifndef _notused
#define _notused(x) ((x)=(x))
#endif


extern int      mkhost(ShObjDef *sh);
extern int      mktarget(ShObjDef *sh);


enum {
	DIAG_DEBUGLEVEL    = 5,
	DIAG_INFOLEVEL     = 10,
	DIAG_ERRORS        = 20
};



/*- invoke various development tools (compilers, linkers, ...) */
extern int cc(char *src, char *dest, char *opts);
extern int assemble_exports(char *src, char *dest, char *opts);
extern int assemble_branch(char *src, char *dest, char *opts);
extern int gas(char *src, char *dest, char *opts);
extern int archive(char *arch, char *sfile, char *opts);
extern int ld(char *src, char *dest, char *opts, ulong_t offs);




#ifndef skeleton_h
#include "skeleton.h"
#endif

#ifndef symbol_h
#include "symbol.h"
#endif

#ifndef globals_h
#include "globals.h"
#endif

extern int diag_close(void );
extern int diag_level(int nlevel);
extern int diag_file(char *fname);
extern int diag_msg(int level,char *fmt,... );
extern int diag_write(int level,char *buf,int n);


extern void fatalerr(char *fmt,... );
extern void warning(char *fmt,... );
extern void error(char *fmt,... );
extern int fcat(FILE *dest,FILE *src);
extern int xunlink(char *name,const char *func);
extern FILE *xfopen(char *nam,const char *mode,const char *func);
extern void *xcalloc(int nelem,int elsize,char *func);
extern void *xmalloc(int nelem,char *func);
extern void *xrealloc(void *p,int msize,char *func);
extern char *xstrdup(char *src,const char *func);
extern char *temp(char *prefix,const char *postfix);
extern int untemp(char *name,int no_unlink);

#endif
