
#include "aout.h"

dump_data(FILE *out, int len, int _getc(void *fp), void *fp)
{
	int	i;
	unsigned char	buf[16];
	fprintf(out,"% 8.8x ",0);
	for (i=0; i < len; i++) {
		if (i && !(i % 16)) {
			int	j;
			for (j=0; j < 16; j++) {
				if (buf[j] < ' ' || buf[j] > 127) {
					putc('.',out);
				} else {
					putc(buf[j],out);
				}
			}
			putc('\n',out);
			fprintf(out,"% 8.8x ",i);
		}
		fprintf(out,"%02.2x ",buf[i%16]=_getc(fp));
	}
	if (i && !(i % 16)) {
		int	j;
		for (j=0; j <= i % 16; j++) {
			if (buf[j] < ' ' || buf[j] > 127) {
				putc('.',out);
			} else {
				putc(buf[j],out);
			}
		}
	}
	putc('\n',out);
	return 0;
}


static char *maxch;
int handc(char *fp)
{
	if (fp > maxch) {
		return -1;
	}
	return *fp++;
}

dumpobj(FILE *f, struct image *aout)
{

	fprintf(f,"magic = 0%o, processor = %d, flags = 0%o\n",
		N_MAGIC(aout->edata),N_MACHTYPE(aout->edata),N_FLAGS(aout->edata));
	fprintf(f,"text = 0x%x data = 0x%x bss = 0x%x\n",
		aout->edata.a_text,aout->edata.a_data,aout->edata.a_bss);
	fprintf(f,"entrypt = 0x%x\n",aout->edata.a_entry);

	fprintf(f,"text starts at %x\n",N_TXTOFF(aout->edata));
	fprintf(f,"data starts at %x\n",N_DATOFF(aout->edata));
	
#if 0
	fprintf(f,"text(%d):\n",aout->edata.a_text);
	maxch = aout->edata.a_text + aout->
	dump_data(f,aout->edata.a_text,getc,in);
	
	fprintf(f,"data(%d):\n",aout->edata.a_data);
	fseek(in,N_DATOFF(aout->edata),SEEK_SET);
	dump_data(f,aout->edata.a_data,getc,in);
#endif
	
	if (aout->ntlist) {
		fprintf(f,"text relocation(%d):\n",aout->edata.a_trsize);
		maxch = (char *) (aout->tlist + aout->ntlist);
		dump_data(f,aout->edata.a_trsize,handc,maxch);
	}
	if (aout->ndlist) {
		fprintf(f,"data relocation(%d):\n",aout->edata.a_drsize);
		maxch = (char *) (aout->dlist + aout->ndlist);
		dump_data(f,aout->edata.a_drsize,handc,maxch);
	}
	
	if (aout->nsyms) {
		fprintf(f,"symbol table(%d):\n",aout->edata.a_syms);
		maxch = (char *) (aout->symtab + aout->nsyms);
		dump_data(f,aout->edata.a_drsize,handc,maxch);
	}	
	if (aout->strsize) {
		fprintf(f,"string table(%d):\n",aout->strsize);
		maxch = aout->strs + aout->strsize;
		dump_data(f,aout->strsize,handc,maxch);
	}
	return 0;
}

dump_relocs(FILE *out,struct relocation_info *rtab, int nrtab,
		struct nlist *nlist)
{
	int	i;
	
	for (i=0; i < nrtab; i++) {
		fprintf(out,"0x%x,%d %s ",
			rtab[i].r_address, 1 << rtab[i].r_length,
			rtab[i].r_pcrel ? "(pc)" : "");
			
		if (rtab[i].r_extern) {
			dump_sym(out,nlist+rtab[i].r_symbolnum);
		} else {
			fprintf(out,"extern ");
			switch (rtab[i].r_symbolnum) {
			case N_TEXT: fprintf(out,"text\n");	break;
			case N_DATA: fprintf(out,"data\n");	break;
			case N_BSS:  fprintf(out,"bss\n");	break;
			case N_ABS:  fprintf(out,"abs\n");	break;
			default:     fprintf(out,"huh<%d>\n",rtab[i].r_symbolnum);
			}
		}
	}
	return 0;
}

dump_sym(FILE *out, struct nlist *n)
{
	int	t = n->n_type;	
	fprintf(out,"%s(",n->n_un.n_name ? n->n_un.n_name : "*nullptr*");
	if (t & N_EXT) {
		fprintf(out,"extern ");
		t &= ~N_EXT;
	}
	switch (t) {
	case	N_UNDF:	fprintf(out,"undef "); break;
	case	N_ABS:	fprintf(out,"abs "); break;
	case	N_TEXT:	fprintf(out,"text "); break;
	case	N_DATA:	fprintf(out,"data "); break;
	case	N_BSS:	fprintf(out,"bss "); break;
	case	N_FN:	fprintf(out,"file "); break;
	case	N_TYPE:	fprintf(out,"type "); break;
	case	N_STAB:	fprintf(out,"stab "); break;
	case	N_INDR:	fprintf(out,"indirect "); break;
	case	N_SETA:	fprintf(out,"set abs "); break;
	case	N_SETT:	fprintf(out,"set text "); break;
	case	N_SETD:	fprintf(out,"set data "); break;
	case	N_SETB:	fprintf(out,"set bss "); break;
	case	N_SETV:	fprintf(out,"set vect "); break;
	default:
		fprintf(out,"<%d> ",t);
	}
	fprintf(out, "other=%d,desc=%d,value=%d)\n",
		n->n_other,n->n_desc,n->n_value);
	return 0;
}
