#include <string.h>
#include <errno.h>
#include "coff.h"

int
coff::print_hdr(FILE *f)
{
	fprintf(f,"magic=0%o, sections=%d, nsyms=%d, flags=%x\n",
		header.f_magic, header.f_nscns,
		header.f_nsyms, header.f_flags);
	return 0;
}

int
coff::print_opthdr(FILE *f)
{
	if (!header.f_opthdr) {
		return 0;
	}
	fprintf(f,"aout:: magic=0%o, textsize=%d, datasize=%d, bss=%d, eip=%x\n",
		aout.magic, aout.tsize, aout.dsize, aout.bsize,
		aout.entry);
	return 0;
}

int
coff::print(FILE *f)
{
	print_hdr(f);
	print_opthdr(f);
	for (int i=0; i < header.f_nscns; i++) {
		sections[i].print(f);
	}
	symtab->print(f);
	return 0;
}
