#include "coff.h"
#include "u386.h"
#include <ctype.h>


int
Sect::load(FILE *fp, long offset)
{
	fseek(fp, offset, SEEK_SET);
	fread(&hdr,sizeof hdr, 1, fp);

	data = new char [hdr.s_size];
	fseek(fp,hdr.s_scnptr, SEEK_SET);
	fread(data, 1, hdr.s_size, fp);

	if (hdr.s_nreloc) {
		reloctab = new RELOC [hdr.s_nreloc];
		fseek(fp,hdr.s_relptr, SEEK_SET);
		fread(reloctab, sizeof *reloctab, hdr.s_nreloc, fp);
	} else {
		reloctab = 0;
	}
	return 0;
}

int
Sect::print(FILE *f)
{
	int	i;
	fprintf(f,"section %s, %d bytes, flags=%x\n",
		hdr.s_name, hdr.s_size, hdr.s_flags);
	fprintf(f,"sect offs %d, rel offs %d, lno offs %d\n",
		hdr.s_scnptr, hdr.s_relptr, hdr.s_lnnoptr);

	if (hdr.s_flags & STYP_TEXT) {
		long addr = 0;
		for (addr=0; addr < hdr.s_size; ) {
			char obuf[80];
			int l = i386dis(addr,data+addr,obuf);
			fprintf(f,"%08.8lx\t%s\n",addr,obuf);
			addr += l;
		}
	} else {
		for (i=0; i < hdr.s_size; i+=16) {
			int j;
			fprintf(f,"% .8lx ",i);
			for (j=0; j < 16 && i+j < hdr.s_size; j++) {
				fprintf(f,"%02.2x ",data[i+j]);
			}
			for (j=0; j < 16 && i+j < hdr.s_size; j++) {
				fputc(isprint(data[i+j]) ? data[i+j] : '.',f);
			}
			fputc('\n',f);
		}
	}
	for (i=0; i < hdr.s_nreloc; i++) {
		fprintf(f,"reloc %d: @$%x = symbol(%d)",
			i, reloctab[i].r_vaddr, reloctab[i].r_symndx);
		switch (reloctab[i].r_type) {
		case	R_ABS:	fprintf(f,"absolute\n"); break;
		case	R_DIR16:fprintf(f,"16-bit direct\n"); break;
		case	R_REL16:fprintf(f,"16-bit relative\n"); break;
		case	R_DIR32:fprintf(f,"32-bit direct\n"); break;
		case	R_SEG12:fprintf(f,"16-bit segment\n"); break;
		case	R_PCRLONG:fprintf(f,"32-bit relative\n"); break;
		default:
			fprintf(f,"**unkown relocation type**\n"); break;
		}
	}
	return 0;
}
