#include <string.h>
#include <stdlib.h>
#include "coff.h"

Symbol::Symbol(char *strs)
{
	strings = strs;
	nsyms = 0;
	nused = 0;
	stab  = 0;
}

Symbol::~Symbol(void)
{
	if (nsyms)	delete stab;
}
#ifndef MINALLOC
#define MINALLOC 64
#endif
int
Symbol::install(SYMENT *sy, AUXENT *alist)
{
	char	*name;
	if (sy->_n._n_nptr[0] == 0) {
		name = strings+sy->n_offset;
	} else {
		name = new char [SYMNMLEN+1];
		strncpy(name,sy->n_name,SYMNMLEN);
		name[SYMNMLEN] = '\0';
	}
	sy->n_nptr = name;
	if (nused == nsyms) {
		symp *p = (symp *)realloc(stab,(nsyms+MINALLOC) * sizeof *p);
		if (!p) {
			return -1;
		}
		nsyms += MINALLOC;
		stab = p;
	}
	stab[nused].sym = *sy;
	stab[nused].aux = alist;
	nused++;
	return 0;
}
symp *Symbol::lookup(char *name)
{
	int	i;
	for (i=0; i < nused; i++) {
		if (strcmp(name, stab[i].sym.n_nptr) == 0) {
			return stab+i;
		}
	}
	return 0;
}
