


/*-
 * lmf.c: access lmf files
 */

#include <libc.h>
#include <sys/lmf.h>
#include "ldfile.h"

int
ldf_seglen(char *fname, LdInfo *ldi)
{
	struct _lmf_header lh;
	struct _lmf_definition lr;
	ulong_t	segs[2];
	FILE	*f;
	if ((f=fopen(fname, "r")) == 0) {
		return -1;
	}
	fread(&lh, sizeof lh, 1, f);
	fread(&lr, sizeof lr, 1, f);
	fread(segs, sizeof *segs, 2, f);
	fclose(f);

	ldi->ld_vaddr = lr.flat_offset;
	ldi->ld_tsize = segs[0] & ~0xf0000000;
	ldi->ld_dsize = segs[1];
	ldi->ld_bsize = lr.heap_nbytes;
	ldi->ld_ssize = lr.stack_nbytes;
	return 0;
}
