/*
 * omf_lnames: define a list of names (symbolic) in object file.
 * These names are typically used for segment and group naming.
 */
#include "omf.h"
#include <string.h>

#ifndef MAX_OMFREC
#define	MAX_OMFREC	0xa0
#endif

omf_lnames(FILE *obj, char **names, int nnames)
{
	orec_t	*r;
	int	i;
	int	slen;
	r = omf_allocrec();
	for (i=0; i < nnames; i++) {
		if (omf_len(r) + (slen=strlen(names[i])) +1 >= MAX_OMFREC) {
			omf_putrec(obj, r, CMD_LNAMES);
			omf_clear(r);
		}
		omf_putname(r,names[i],slen);
	}
	if (omf_len(r)) 
		omf_putrec(obj, r, CMD_LNAMES);
	omf_freerec(r);
	return 0;
}
