#include <libc.h>
#include "codegen.h"
#include "omf.h"


static char *segnames[] = {
	"",
	"CODE",
	"DATA",
	"BSS",
	"DGROUP", 
	"_TEXT", 
	};
	
#define _CSEG	1
#define _SEGLEN 6

mk_jump(FILE *fp, char *lsym, char *rsym)
{
	orec_t	*r;
	char	lname[256];
	char	rname[256];

/* watcom name semantics */
	sprintf(lname,"_%s",lsym);
	sprintf(rname,"%s_", rsym);

	r = omf_allocrec();
	
	omf_theader(fp,rname);
	omf_msobj(fp);
	
	omf_lnames(fp,segnames, 6);
	/* define code segment */
				/* align combine type */
	omf_putbyte(r, (ALIGN_BYTE<<5)|(COMB_ADDOFF<<2)|1);
	omf_puteither(r, _SEGLEN);	/* length of code  segment */
	omf_putbyte(r, 6);	/* name of segment */
	omf_putbyte(r, 2);	/* segment class-name (lnames index) */
	omf_putbyte(r, 1);	/* overlay flags */
	omf_putrec(fp,r,CMD_SEGD32);
	omf_clear(r);

	omf_putname(r,lname, strlen(lname));
	omf_putindex(r,0);
	omf_putname(r, rname, strlen(rname));
	omf_putindex(r, 0);
	omf_putrec(fp,r,CMD_EXTDEF);
	omf_clear(r);

	omf_putindex(r, _CSEG);	/* section */
	omf_puteither(r, 0);	/* offset */

	omf_putbyte(r, 0xff); omf_putbyte(r, 0x25);
	omf_putdword(r,0);
	omf_putrec(fp,r,CMD_LEDA32);
	omf_clear(r);

/* put a fixup for this record */
	omf_putbyte(r, FIXUPP_FIXUP | (LOC_MS_OFFSET_32 << 2) | FIXDAT_MBIT);
	omf_putbyte(r, 2); /* offset */
	omf_putbyte(r, (F_EXT<<4)|T_EXTWD|0x04);
	omf_putindex(r, 1);
	omf_putindex(r, 1);
	omf_putrec(fp, r, CMD_FIXU32);
	omf_clear(r);

	omf_putbyte(r, 0);
	omf_putbyte(r, _CSEG);
	omf_putname(r, rname, strlen(rname));
	omf_puteither(r,0);
	omf_putindex(r,0);
	omf_putrec(fp, r, CMD_PUBD32);

	omf_freerec(r);
/* put module end def */	
	omf_modend(fp, 0);
	return 0;
}
