

#include <libc.h>
#include "codegen.h"
#include "omf.h"


static char *segnames[] = {
//	"",
	"CODE",
//	"DATA",
//	"BSS",
//	"DGROUP", 
	"_TEXT2", 
	};
	

mktextlabel(FILE *fp, char *symnam)
{
	orec_t	*r;

	
	omf_theader(fp,"etext");
	omf_msobj(fp);
	
	omf_lnames(fp,segnames, 2);
	
	r = omf_allocrec();
/*-
 * Define an external name
 */
	omf_putname(r, symnam, strlen(symnam));
	omf_putindex(r, 0);
	omf_putrec(fp, r, CMD_EXTDEF);
	omf_clear(r);
/*-
 * define code segment
 */
	/* align combine type */
	omf_putbyte(r, (ALIGN_BYTE<<5)|(COMB_ADDOFF<<2)|1);
	omf_puteither(r, 0);	/* length of code  segment */
	omf_putbyte(r, 2);	/* name of segment */
	omf_putbyte(r, 1);	/* segment class-name (lnames index) */
	omf_putbyte(r, 1);	/* overlay flags */
	omf_putrec(fp,r,CMD_SEGD32);
	omf_clear(r);

/*-
 * define the same name PUBLIC at offset 0 in this code segment
 */
	omf_putbyte(r, 0);
	omf_putbyte(r, 1);
	omf_putname(r, symnam, strlen(symnam));
	omf_puteither(r, 0);
	omf_putindex(r,0);
	omf_putrec(fp, r, CMD_PUBD32);
	omf_clear(r);

	omf_freerec(r);
/*-
 * put module end def
 */	
	omf_modend(fp, 0);
	return 0;
}

mketext(FILE *fp)
{
	return mktextlabel(fp, "_etext");
}
#if 0
main()
{
	mketext(stdout);
}
#endif
