#ifndef symbol_h
#define symbol_h

#ifndef map_h
#include "map.h"
#endif


typedef struct {
	
	int	is_sect:1,
		is_data:1,
		is_code:1,
		is_exported:1,
		is_branch:1,
		is_imported:1;
	int	branch_index;
	ulong_t	address;
} Symbol;

#define IS_BRANCH(p)	((p)->is_branch)
#define IS_EXPORTED(p)	((p)->is_exported)
#define	IS_SECTION(p)	((p)->is_sect)
#define IS_CODE(p)      ((p)->is_code)
#define IS_DATA(p)      ((p)->is_data)

extern Symbol *sym_lookup(char *name);
extern Symbol *sym_install(char *name, Symbol *p);
extern char *sym_cname(char *nam); /* C name */
extern char *sym_ename(char *nam); /* assembly/linker name */
extern Symbol *new_symbol(void);
extern int   sym_apply(int (*f)(), void *p);

/*-
 * special constructors
 */
extern int code_symbol(char *name);
extern int data_symbol(char *name);
extern int anon_symbol(char *name);
extern int sect_symbol(char *name, long addr);
extern int export_symbol(char *name);

#endif
